#ifndef MSP_GL_VERTEXARRAYBUIDER_H_
#define MSP_GL_VERTEXARRAYBUIDER_H_

#include <vector>
#include "vertexbuilder.h"
#include "vertexformat.h"

namespace Msp {
namespace GL {

class VertexArray;

class VertexArrayBuilder: public VertexBuilder
{
private:
	VertexArray &array;

	VertexArrayBuilder(const VertexArrayBuilder &);
public:
	VertexArrayBuilder(VertexArray &);

private:
	virtual void vertex_(const Vector4 &);

	template<typename T>
	void store_attribute(char *, const Vector4 &, bool, unsigned);
};

} // namespace GL
} // namespace Msp

#endif
